package com.gic.haoban.manage.web.controller;

import com.gic.api.base.commons.Page;
import com.gic.enterprise.api.dto.StoreDTO;
import com.gic.enterprise.api.dto.StoreSearchDTO;
import com.gic.enterprise.api.service.StoreService;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.base.api.common.PageResult;
import com.gic.haoban.common.utils.AuthWebRequestUtil;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.service.StaffApiService;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("/store")
public class StoreController extends WebBaseController{
	@Autowired
	private StoreService storeService;
    @Autowired
    private StaffApiService staffApiService;

	//门店列表
	@RequestMapping("/find-simple-page")
	public HaobanResponse storeList(Integer storeType,String enterpriseId,BasePageInfo basePageInfo) {
        List<String> storeRolesByClerkId = staffApiService.getHaoBanStoreRolesByClerkId(AuthWebRequestUtil.getLoginUser().getClerkId());
        PageResult<StoreDTO> pageVo = new PageResult<>();
        if (CollectionUtils.isEmpty(storeRolesByClerkId)) {
            return resultResponse(HaoBanErrCode.ERR_1,pageVo);
        }
        // TODO: 2022/5/19 确认一下到底是用分页还是不分页
        //storeService.getStores(storeRolesByClerkId.toArray(new String[storeRolesByClerkId.size()]));
        Page page = new Page<>();
        page.setCurrentPage(basePageInfo.getPageNum());
        page.setPageSize(basePageInfo.getPageSize());
        StoreSearchDTO storeSearchDTO = new StoreSearchDTO();
        storeSearchDTO.setEnterpriseId(enterpriseId);
        storeSearchDTO.setStatus("2");
        storeSearchDTO.setStoreType(storeType);
        Page<StoreDTO> resultPage = storeService.storeListPage(page, storeSearchDTO);
        List<StoreDTO> storeDTOList = resultPage.getResult();
        List<StoreDTO> storeDTOs = new ArrayList<>();
        for (String s : storeRolesByClerkId) {
            for (StoreDTO storeDTO : storeDTOList) {
                String storeId = storeDTO.getStoreId();
                if (s.equals(storeId)) {
                    storeDTOs.add(storeDTO);
                }
            }
        }
        pageVo.setList(storeDTOs);
        pageVo.setPageNum(page.getCurrentPage());
        pageVo.setPages(resultPage.getPages());
        pageVo.setPageSize(page.getPageSize());
        pageVo.setTotal(storeDTOs.size());
        return resultResponse(HaoBanErrCode.ERR_1,pageVo);
	}
	
	
	
}
